

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

  CR = 62                                               ' ASCII <CR>
  LF = 10                                               ' ASCII <LF>
  serXmit   = 7                                     
  serRecv   =  6                                       
  
  LCD_PIN   = 24                                        'For AMC1602AR serial LCD on P14
  LCD_BAUD  = 19_200                                    'Baud rate for communication to AMC1602AR LCD is set
  LCD_LINES = 2
  comma = 44

OBJ
 ' text          :               "vga_Drive" 
  uart          :               "FullDuplexSerial"
  lcd           :               "Debug_Lcd_AMC1602"
  sdfat         :               "fsrw"
  num : "simple_numbers"  
VAR

Byte  Rx, dataIn[100], ct, crt, Rd, numSent, lcdShow,   DataOut[100], ctOut
Byte V1, V2, V3, V4, Hex1, Hex2, Hex3, Hex4, update, dot, PIDChar1, PIDChar2, lcdMode, rec, index1, index2, index3, sw1, sw2, maxmode
Byte mode, index, fast, tRef, recData[100] 
long txDisp, units ,  AnsaB, Ansa, stack1[20], stack2[20], stack3[20]  ,  AnsaA , AnsaC , OK[2]  ,q
byte tbuf[20],r, sta
   byte bigbuf[8192]


pub main   
dira[10]~~
rec := 0 
'text.start(16)                                                                  ' Start the monitor
'^text.out(00)  
 
uart.start(serRecv, serXmit, 3, 9600)                                           ' Start the RS232 communications
uart.rxflush                                                                    ' Flush the buffer       
lcd.init( LCD_PIN,LCD_BAUD,LCD_LINES)                                           ' Start the LCD display
lcd.cls                                                                         ' Clear the display
  lcd.str(string("Mounting SD..."))        
   
    waitcnt(80_000_000 + cnt)
  r:=  sdfat.mount(00)
  lcd.dec(r)
    waitcnt(80_000_000 + cnt)    


    
   AnsaA := 200



  
   lcd.cls
   if r ==0
      lcd.str(string("Mounted."))
      waitcnt(120_000_000 + cnt)  
      sdfat.opendir
      repeat while 0 == sdfat.nextfile(@tbuf)
            sta := cnt
   else
       lcd.gotoxy(2,1)
       if r == -20
          lcd.str(string("NOT FAT16 DISK"))
       elseif r == -21
          lcd.str(string("BAD BYTES/SCTR"))
         
       lcd.str(string("Failed!"))

  sdfat.popen(string("Data2.csv"), "a")
  
      

  
  
  
'start switches in new cogs


  cognew(switch1, @stack1)                                                      ' Start switch 1 monitoring (increment 'mode')
  cognew(switch2, @stack2)                                                      ' Start switch 2 monitoring (decrement 'mode')
  cognew(switch3, @stack3)                                                      ' Start switch 3 monitoring ('record')

  
''*text.start(16)                                                                  ' Start the monitor
'*text.out(00)                                                                    ' Reset the display
'*text.str(string("TEST"))                                                        ' Place the '*text "TEST" on the monitor
lcd.cls
lcd.str(string("Awaiting"))                                                     ' Put "Awaiting Connection..." o LCD
lcd.gotoxy(2,1)
lcd.str(string("Connection..."))

lcdshow:=0                                                                      ' Turn off the echoing of RS232 data on the LCD screen whilst we are waiting.



'callWaitRx                                                                      ' Wait until some data is received

mode := 1                                                                       ' What data will be polled initially
                                                                   ' We will show it on the LCD
lcdMode := 0                                                                    ' String or Decimal? 
maxmode :=10                                                                    ' This is the maximum number of 'modes'


  
   

  
  
  if sw1==1 and sw2 == 1
    fast := 1
  else
    fast := 0
         
          
  waitcnt(90_000_000 + cnt)                                                   'Wait a while
  lcdshow := 1                       
  callATZ                                                                       'Send an ATZ Reset command
                                              
  callDoWait                                                                    'Wait a while
  callRV

  callDoWait                                                                    'Wait a while
  callI

  callDoWait                                                                    'Wait a while
  callAt1

  callDoWait                                                                    'Wait a while
  callDP

  calldowait
  'callTimeOut
  update := 1
  lcdshow:=0                                                                    ' We will NOT show it on the LCD


  'At this point we need to decide what we are going to do:
  ' 1) Read fault codes?
  ' 2) View live data?

 'callNegotiate
 

repeat  
  
     
      Hex1 := 48                                                                  ' Set all the Hex variables to ASCII '0' 
      Hex2 := 48                                                                  ' Set all the Hex variables to ASCII '0'   
      Hex3 := 48                                                                  ' Set all the Hex variables to ASCII '0'   
      Hex4 := 48                                                                  ' Set all the Hex variables to ASCII '0'   
   
      case Mode                                                                   ' Call the appropriate subroutine based upon the mode
        1:
          callCoolant
         
        2:  
          callLambda
   
        3:
          callLoad
   
        4:
          callAFM
   
        5:
          callMap
   
        6:
          callRPM
   
        7:
          callSpeed
   
        8:
          callAdvance
   
        9:
          callIAT
   
        10:
           callThrottle
   
     
           
         
    '  waitcnt(90_000_000 + cnt)                                                   'Wait a while
      !outa[10]
       
      
      
  if rec == 1
     'Recording mode
     lcdshow:=1
     'lcdshow := 0
       sdfat.popen(string("Data3.csv"), "a")
     
     
     'lcd.cls
     
     lcd.gotoxy(2,16)
  'lcd.str(string("Recording"))
     lcd.str(string("R"))       
    ' lcd.str(txDisp)
    ' lcdshow := 0
'     tRef := cnt
     'AnsA := 200
     

     bytemove(@dataOut,num.dec(Cnt),32)
     sdfat.pwrite(@dataOut,32)
     sdfat.pputc(44)

     bytemove(@dataOut,num.dec(AnsaA),5)
     sdfat.pwrite(@dataOut,5)
     
     sdfat.pputc(13)
     sdfat.pclose
     'waitcnt(tRef + 20_000_000)
     !outa[13]
    
     if mode==6
       mode:=7
     elseif mode == 7
         mode := 2
     elseif mode == 2
         mode:=6
  else
    lcdshow:=1
 
pub callAT
  uart.tx(65)                   'A'
  uart.tx(84)                   'T'
  uart.tx(32)                   ' ' 

pub callE0
  callAT
  uart.tx(69)                   'A'
  uart.tx(48)                   'T'
  callCR                   ' '
  numSent := 5
  
pub callCR
  uart.tx(13)
pub calltimeOut
callAT
  txDisp:= string("Setting time-out")
  uart.tx(66)                   'B
  uart.tx(82)                   'R
  uart.tx(72)                   'T
  uart.tx(32)                   'Space
  uart.tx(48)                   '0
  uart.tx(66)                   '7
  callCR                        'Carriage return
  numSent := 4
  callWaitRx            

pub callATZ
  txDisp:= string("Reset:")
  callAT
  uart.tx(90)                   'Z'
  callCR                        'Carriage return
  numSent := 4
  callWaitRx
  
pub callI
  txDisp:= string("Version ID:")
  callAT
  uart.tx(73)                   'I'
  callCR
  numSent := 4
  callWaitRx
  
pub callWS
  txDisp:= string("Warm start")
  callAT
  uart.tx(87)                   'WS'
  uart.tx(83)                   'S'
  callCR
  numSent := 5
  callWaitRx
  
pub callAt1
  txDisp:= string("Description:")
  callAT
  uart.tx(64)
  uart.tx(49)
  callCR
  numSent := 5
  callWaitRx

  'callAT
  'uart.tx(65)
  'uart.tx(84)
  'uart.tx(49)
  'callCR
  'numSent := 5
  'callWaitRx
  
pub callRV
   txDisp:= string("Battery Voltage:")
   callAT
   uart.tx(82)
   uart.tx(86)
   callCR
   numSent := 5
   callWaitRx

pub callDP
   txDisp:= string("Protocol:")
   callAT
   uart.tx(68)
   uart.tx(80)
   callCR
   numSent := 5
   callWaitRx


   'SP A0

pub callMA
   txDisp:= string("Messages:")
   callAT
   uart.tx(77)
   uart.tx(65)
   callCR
   numSent := 5
   repeat 300
    callWaitRx

pub callCoolant    'PID 05
    txDisp:= string("Coolant temp")
    units := string(" C")   
    PIDChar1 := 48
    PIDChar2 := 53
    callPID01
    lcdshow :=0

    callWaitRx    
     
    Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]


    '*text.dec(hex3)
    '*text.dec(hex4)
   
    callhexToDec 

    AnsaA := AnsaA - 40
    
    ''*call'*textShow
    callLCDShow

pub callLoad      'PID 04
   txDisp:= string("Engine Load")
   units := string(" %")   
   PIDChar1 := 48
   PIDChar2 := 52
   callPID01
   lcdshow :=0

   callWaitRx
  
   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]

   callhexToDec 

   AnsaA := AnsaA *100 / 255

   '*call'*textShow    
   callLCDShow

pub callFuelPressure
   txDisp:= string("Fuel press")
   units := string(" kPag")   
   PIDChar1 := 48
   PIDChar2 := 65
   callPID01
   lcdshow :=0

   callWaitRx

   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]

   callhexToDec 

   AnsaA := AnsaA * 3

   '*call'*textShow
   callLCDShow

pub callMAP     'PID 0b
   txDisp:= string("MAP px")
   units := string(" kPa")   
   PIDChar1 := 48
   PIDChar2 := 66
   callPID01
   lcdshow :=0
   
   callWaitRx

   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]

   callhexToDec 

   AnsaA := AnsaA *100 / 255

   '*call'*textShow     
   callLCDShow

pub callRPM              'PID 0C
   txDisp:= string("Engine RPM")
   units := string(" rpm")   
   PIDChar1 := 48
   PIDChar2 := 67
   callPID01
   lcdshow :=0
   
   callWaitRx

   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 9]
    Hex4 := dataIn[ct - 8]

    Hex1 := dataIn[ct - 6]           ' ->
    Hex2 := dataIn[ct - 5]

'lcd.cls   
'lcd.dec(hex1)
'lcd.putc(45)
'lcd.dec(hex2)
'lcd.putc(45) 
'lcd.dec(hex3)
'lcd.putc(45) 
'lcd.dec(hex4)
'lcd.putc(42)
    
   callhexToDec

   AnsaC := ((AnsaA  * 256) + AnsaB)/4
   AnsaA := AnsaC  
   '*call'*textShow     
   callLCDShow

pub callSpeed      'PID 0D
   txDisp:= string("Speed")
   units := string(" km/h")   
   PIDChar1 := 48
   PIDChar2 := 68
   callPID01
   lcdshow :=0
   
   callWaitRx

   '*text.str(string("Converting"))
     
  Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]

   callhexToDec 

   AnsaA := AnsaA

   '*call'*textShow     
   callLCDShow

pub callAdvance    'PID 0E
   txDisp:= string("Advance")
   units := string(" Deg")   
   PIDChar1 := 48
   PIDChar2 := 69
   callPID01
   lcdshow :=0
   
   callWaitRx

   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]

   callhexToDec 

   AnsaA := AnsaA / 2 - 64

   '*call'*textShow     
   callLCDShow

pub callIAT    'PID 0f
   txDisp:= string("Inlet Temp")
   units := string(" C")   
   PIDChar1 := 48
   PIDChar2 := 70
   callPID01
   lcdshow :=0
   
   callWaitRx

   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]

   callhexToDec 

   AnsaA := AnsaA - 40

   '*call'*textShow     
   callLCDShow
pub callAFM    'PID 10
   txDisp:= string("Airflow")
   units := string(" g/s")   
   PIDChar1 := 49
   PIDChar2 := 48
   callPID01
   lcdshow :=0
   
   callWaitRx

   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 9]
    Hex4 := dataIn[ct - 8]

   Hex1 := dataIn[ct - 6]
    Hex2 := dataIn[ct - 5]
   callhexToDec 

   '^text.out(13)
   '^text.dec(AnsaA)
   '^text.out(13)
   '^text.dec(AnsaB)
   '^text.out(13)
   AnsaC := ((AnsaA * 256)+ AnsaB)/100
   '^text.dec(ansac)
   '^text.out(13)
   ansaA:=ansaC 
'   txDisp:=dataIn
   'call'^textShow     
   callLCDShow
pub callThrottle
   txDisp:= string("Throttle pos")
   units := string(" %")   
   PIDChar1 := 49
   PIDChar2 := 49
   callPID01
   lcdshow :=0
   
   callWaitRx
   '*text.str(string("Converting"))
     
   Hex3 := dataIn[ct - 6]
    Hex4 := dataIn[ct - 5]

   callhexToDec 

   AnsaA := AnsaA * 100 / 255

   '*call'*textShow     
   callLCDShow

pub callLambda
   {{ This procedure sends "01 14" to the ELM327 unit. This is Mode 1, PID 14. The 01 is sent via the 
      callPID01 procedure.}}

   
   units := string(" ")   
   PIDChar1 := 49
   PIDChar2 := 52
   callPID01
   lcdshow :=0
   
   callWaitRx
     
   Hex3 := dataIn[ct - 9]
   Hex4 := dataIn[ct - 8]

   Hex1 := dataIn[ct - 6]
   Hex2 := dataIn[ct - 5]
   
   callhexToDec 
 
   'AnsaA := AnsaB  * 5
   AnsaA := (AnsaA * 5)/8

   txDisp:= string("Lambda")  
   {{if rec == 0
      lcd.cls
      txDisp := string(".")
      q:=    AnsaA/100*16  +1
      cnt :=0 
      repeat q-1
         lcd.str(string("-"))   

      lcd.str(string("+"))
      repeat 15-q
         lcd.str(string("-"))  }}

     
   callLCDShow
   lcd.gotoXY(2,13)
   if AnsaA < 20
      lcd.str(string("Lean"))
   if AnsaA > 80
      lcd.str(string("Rich"))

      
    
pub callWaitRx
   longfill(dataIn, 100, 0)                             ' Empty the dataIn variable
   longfill(dataOut, 100, 0)
   ct := 0                                              ' Counter for the number of characters received
   ctOut := 0
   '*text.out(13)
   '*text.str(string("Waiting"))                                           
   if lcdshow ==1 
        lcd.cls                                              ' Clear the LCD
        lcd.str(txDisp)                                      ' Show the data on the first row
        lcd.gotoxy(2,1)                                      ' Move the cursor to the next line
   repeat while Rx <>= 62                               ' Continue to collect data until the end of the data      
     Rx := uart.Rx                                      ' Get character from Rx Buffer
     dataIn[ct++] := Rx                                 ' Place the received character in the dataIn variable
     'text.out(dataIn[ct-1])                             ' Echo characters received to screen
     
     if lcdShow == 1
       if dataIn[ct-1] <> 62
           lcd.putc(dataIn[ct-1])
       dataOut[ctOut++] := dataIn[ct -1]
       
   Rx:=42                                               ' Set 'Rx' to a value that is NOT 62, otherwise it won't
                                                        '    go through the 'repeat while' loop on next encounter
   uart.rxflush                                         ' Flush the Rx buffer
   
   
   'text.out(42)                                         ' Indicate end of Rc'd data with an asterisk

   
      
pub callhexToDec 
V1 := 0
V2 := 0
V3 := 0
V4 := 0

if Hex1 > 64
   V1 := Hex1 - 55
else
   V1 := Hex1 - 48

if Hex2 > 64
   V2 := Hex2 - 55
else
   V2 := Hex2 - 48

if Hex3 > 64
   V3 := Hex3 - 55
else
   V3 := Hex3 - 48

if Hex4 > 64
   V4 := Hex4 - 55
else
   V4 := Hex4 - 48

'^text.out(13)
'^text.dec(hex1)
'^text.out(45)
'^text.dec(hex2)
'^text.out(45) 
'^text.dec(hex3)
'^text.out(45) 
'^text.dec(hex4)
'^text.out(42)

AnsaA := (V3 * 16) + V4
AnsaB := (V1 * 16) + V2
 

pub callLCDShow
'if rec <> 1
   lcd.cls                                              ' Clear the LCD
   lcd.str(txDisp)                                     ' Show the data on the first row
   lcd.putc(58)
   lcd.gotoxy(2,1)

   if lcdMode == 0
     lcd.dec(AnsaA)
   else
     lcd.str(Ansa)
 lcd.str(units)
 


   
pub switch1
dira[14]~~
index1~ ' index is initially zero
repeat until ina [ 16 ] == 0 ' make sure button initially off
repeat
   repeat until ina[ 16 ] == 1 ' wait for on
   index1++
   mode++
   sw1:=1
   !outa[14]
   repeat until ina[ 16 ] == 0 ' wait for off 
   waitcnt(clkfreq/index1 + cnt)
   if mode == (maxmode + 1)
    mode := 1
   sw1 := 0
    
   
pub switch2
dira[11]~~
index2~ ' index is initially zero
repeat until ina [ 19 ] == 0 ' make sure button initially off
repeat
   repeat until ina[19 ] == 1 ' wait for on
   index2++
   mode--
   sw2:=1
   !outa[11]
   repeat until ina[ 19 ] == 0 ' wait for off 
   waitcnt(clkfreq/index2 + cnt)
   if mode == 0
    mode := maxmode
   sw2:=0
   

pub switch3
dira[8]~~
dira[13]~~
index3~ ' index is initially zero
repeat until ina [ 20 ] == 0 ' make sure button initially off
repeat
   repeat until ina[ 20 ] == 1 ' wait for on
   index3++
   !outa[8]
   if rec ==0
     rec :=1
     'sdfat.popen(string("Data1.csv"), "a")
   else
     rec :=0
     'sdfat.pclose
   repeat until ina[ 20 ] == 0 ' wait for off 
   waitcnt(clkfreq/index3 + cnt)
   'if mode==12
    mode:=6
   outa[13] := rec    
   
pub callPID01
  '*text.str(string("Requesting"))
  '*text.str(txDisp)
  '*text.out(13)
  uart.tx(48)
  uart.tx(49)
  uart.tx(32)
  uart.tx(PIDChar1)
  uart.tx(PIDChar2)
  callCR
  numSent := 5

'pub '*call'*textShow
 '*text.out(13)
 '*text.str(txDisp)
 '*text.out(58)
 '*text.out(32)
 '*text.dec(AnsaA)
 '*text.out(32)
 '*text.str(units)
pub callDoWait
 if fast <> 1 
   waitcnt(40_000_000 + cnt)